VERSION 5.00
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "RICHTX32.OCX"
Begin VB.Form Form1 
   Caption         =   "String test"
   ClientHeight    =   6075
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4305
   LinkTopic       =   "Form1"
   ScaleHeight     =   6075
   ScaleWidth      =   4305
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command12 
      Caption         =   "instr Reverse"
      Height          =   495
      Left            =   2280
      TabIndex        =   13
      Top             =   5040
      Width           =   975
   End
   Begin VB.CommandButton Command11 
      Caption         =   "descriptors"
      Height          =   495
      Left            =   2280
      TabIndex        =   12
      Top             =   5520
      Width           =   975
   End
   Begin VB.CommandButton Command10 
      Caption         =   "midB$"
      Height          =   495
      Left            =   1080
      TabIndex        =   11
      Top             =   5520
      Width           =   1215
   End
   Begin VB.CommandButton Command9 
      Caption         =   "byte / copymemory"
      Height          =   495
      Left            =   1080
      TabIndex        =   10
      Top             =   5040
      Width           =   1215
   End
   Begin VB.CommandButton Command8 
      Caption         =   "View Code"
      Height          =   495
      Left            =   3240
      TabIndex        =   9
      Top             =   5520
      Width           =   975
   End
   Begin VB.CommandButton Command7 
      Caption         =   "assign"
      Height          =   495
      Left            =   120
      TabIndex        =   7
      Top             =   5520
      Width           =   975
   End
   Begin VB.CommandButton Command6 
      Caption         =   "Command6"
      Height          =   495
      Left            =   120
      TabIndex        =   6
      Top             =   5040
      Width           =   975
   End
   Begin VB.CommandButton Command5 
      Caption         =   "mid$"
      Height          =   495
      Left            =   3240
      TabIndex        =   5
      Top             =   4560
      Width           =   975
   End
   Begin VB.CommandButton Command4 
      Caption         =   "reset"
      Height          =   495
      Left            =   3240
      TabIndex        =   4
      Top             =   5040
      Width           =   975
   End
   Begin VB.CommandButton Command3 
      Caption         =   "byteArray"
      Height          =   495
      Left            =   2280
      TabIndex        =   3
      Top             =   4560
      Width           =   975
   End
   Begin VB.CommandButton Command2 
      Caption         =   "copymemory"
      Height          =   495
      Left            =   1080
      TabIndex        =   2
      Top             =   4560
      Width           =   1215
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Replace"
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   4560
      Width           =   975
   End
   Begin RichTextLib.RichTextBox RichTextBox1 
      Height          =   3975
      Left            =   120
      TabIndex        =   0
      Top             =   600
      Width           =   4095
      _ExtentX        =   7223
      _ExtentY        =   7011
      _Version        =   393217
      TextRTF         =   $"Form1.frx":0000
   End
   Begin VB.Label Lbl1 
      Height          =   375
      Left            =   240
      TabIndex        =   8
      Top             =   120
      Width           =   2535
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'By oigres P (sergio Perciballi) Email: oigres@postmaster.co.uk
'various ways to assign/manipulate strings using
'mid$/copymemory and other functions
Option Explicit

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)
Const numberOfChar = 100000 ''change this to develope different tests

Private Sub Command1_Click()
    'use replace function- 8-10 seconds on 1,00,000;133mhz pentium
    'this can be slow ; runs out of memory with 1,000,000 characters
    Dim ret
    Dim ct As New CTimer
    lastbutton = "Command1"
    ct.start
    Me.RichTextBox1.text = Replace$(Me.RichTextBox1.text, "*", "0")
    MsgBox ct.finish & "ms", , lastButtonCaption


End Sub

Private Sub Command10_Click()
    'use midB$
    Dim ct As New CTimer
    Dim pos As Long
    Dim r$
    lastbutton = "Command10"
    ct.start '
    r$ = RichTextBox1.text
    pos = 0
    Do
        pos = InStrB(pos + 1, r$, "*")
        ''If MsgBox(pos, vbYesNo) = vbNo Then Exit Sub
        If pos <= 0 Then Exit Do
        MidB$(r$, pos, 1) = ChrB$(Asc("0"))
    Loop
    Me.RichTextBox1.text = r$
    MsgBox ct.finish & "ms", , lastButtonCaption
    ''

End Sub

Private Sub Command11_Click()
    'use BSTR 'basic string-> the pointer to unicode byte array
    'swap bstr
    Dim r$, s$, ct As New CTimer
    lastbutton = "Command11"
    ct.start
    ''s$ = String$(100000, "+")
    r$ = String$(numberOfChar, "0")
    'copy r$ descriptor to s$ -> s$ now points to r$
    CopyMemory ByVal VarPtr(s$), ByVal VarPtr(r$), 4   'bstr is 4 bytes
    Me.RichTextBox1.text = s$
    MsgBox ct.finish & "ms", , lastButtonCaption
    ''MsgBox Mid$(r$, 1, 10)
End Sub

Private Sub Command12_Click()
    Dim ct As New CTimer
    Dim r$, pos As Long
    lastbutton = "Command12"
    ct.start
    r$ = RichTextBox1.text

    pos = Len(r$) + 1
    Do
        If pos <= 1 Then Exit Do

        pos = InStrRev(r$, "*", pos - 1)
        If pos <= 0 Then Exit Do
        Mid$(r$, pos, 1) = "0"

    Loop
    Me.RichTextBox1.text = r$
    MsgBox ct.finish & "ms", , lastButtonCaption

End Sub



Private Sub Command2_Click()
    'use copymemory
    Dim ct As New CTimer
    Dim res$, res2$
    lastbutton = "Command2"
    ct.start
    res$ = String$(numberOfChar, "0")
    res2$ = Space$(numberOfChar)

    CopyMemory ByVal StrPtr(res2$), ByVal StrPtr(res$), LenB(res$)
    Me.RichTextBox1.text = res2$
    MsgBox ct.finish & "ms", , lastButtonCaption

End Sub

Private Sub Command3_Click()
    'use byte array
    'unicode uses 2 bytes so 100000*2
    Dim ct As New CTimer, i As Long
    Dim text$, b(numberOfChar * 2) As Byte
    lastbutton = "Command3"
    ct.start ' = GetTickCount
    For i = 0 To (numberOfChar * 2) - 1 Step 2
        b(i) = 48 'Asc("0")
    Next i
    Me.RichTextBox1.text = b()
    MsgBox ct.finish & "ms", , lastButtonCaption

End Sub

Private Sub Command4_Click()
    Dim r$, ct As New CTimer
    'reset the text
    lastbutton = "Command4"
    ct.start
    r$ = String$(numberOfChar, "*")
    Me.RichTextBox1.text = r$
    MsgBox ct.finish & "ms", , lastButtonCaption

End Sub

Private Sub Command5_Click()
    'use mid$
    Dim ct As New CTimer
    Dim pos As Long
    Dim r$
    lastbutton = "Command5"
    ct.start '
    r$ = RichTextBox1.text
    'repeatedly find position of character then replace it
    pos = 0
    Do
        pos = InStr(pos + 1, r$, "*")
        ''If MsgBox(pos, vbYesNo) = vbNo Then Exit Sub
        If pos <= 0 Then Exit Do
        Mid$(r$, pos, 1) = "0"
    Loop
    Me.RichTextBox1.text = r$
    MsgBox ct.finish & "ms", , lastButtonCaption
    ''

End Sub

Private Sub Command6_Click()

    Dim r$, d$
    lastbutton = "Command6"
    r$ = "1234567890"
    d$ = Space$(Len(r$))
    MsgBox VarPtr(r$)
    MsgBox StrPtr(r$)
    CopyMemory ByVal StrPtr(d$), ByVal StrPtr(r$), 6  '3 char 'LenB(r$)
    MsgBox "D$=  " & d$ & ":"
    MsgBox Asc(d$)

End Sub

Private Sub Command7_Click()
    'use assign
    Dim ct As New CTimer
    Dim text$
    lastbutton = "Command7"
    ct.start ' = GetTickCount
    text$ = String$(numberOfChar, "0")

    Me.RichTextBox1.text = text$

    MsgBox ct.finish & "ms", , lastButtonCaption

End Sub

Private Sub Command8_Click()
    On Error Resume Next
    openFile

    '' lastbutton = ""
End Sub

Private Sub Command9_Click()
    'byte array and copymemory
    Dim ct As New CTimer
    Dim b(numberOfChar * 2) As Byte 'note 200000 -unicode string = 2*
    Dim i, r$
    lastbutton = "Command9"
    ct.start
    r$ = String$(numberOfChar, "0")
    CopyMemory b(0), ByVal StrPtr(r$), LenB(r$)
    Me.RichTextBox1.text = b
    MsgBox ct.finish & "ms", , lastButtonCaption
    'lastbutton = "Command9"
End Sub

Private Sub Form_Load()
    Dim s$
    '''numberOfChar = 100000 '
    s$ = String$(numberOfChar, "*")
    Me.RichTextBox1.text = s$
    lastbutton = ""

End Sub

Private Sub RichTextBox1_KeyDown(KeyCode As Integer, Shift As Integer)
    Lbl1.Caption = "character position " & vbCrLf & Me.RichTextBox1.SelStart
End Sub


Private Sub RichTextBox1_KeyPress(KeyAscii As Integer)
    Lbl1.Caption = "character position " & vbCrLf & Me.RichTextBox1.SelStart
End Sub

Private Sub RichTextBox1_KeyUp(KeyCode As Integer, Shift As Integer)
    Lbl1.Caption = "character position " & vbCrLf & Me.RichTextBox1.SelStart
End Sub
